VERSION 5.00
Begin VB.UserControl ZeitFrameCtl 
   Alignable       =   -1  'True
   AutoRedraw      =   -1  'True
   ClientHeight    =   1290
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2715
   ControlContainer=   -1  'True
   BeginProperty Font 
      Name            =   "Lucida Sans Unicode"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H8000000F&
   MousePointer    =   1  'Arrow
   OLEDropMode     =   1  'Manual
   ScaleHeight     =   86
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   181
   ToolboxBitmap   =   "ZeitFrameCtl.ctx":0000
   Begin VB.CheckBox ZeitFrameCtl 
      Height          =   270
      Left            =   120
      TabIndex        =   0
      Top             =   0
      Value           =   1  'Checked
      Width           =   270
   End
   Begin VB.Label lblzFrame 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "ZeitFrameCtl"
      Height          =   240
      Left            =   420
      TabIndex        =   1
      Top             =   0
      Width           =   1215
   End
End
Attribute VB_Name = "ZeitFrameCtl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' Copyright (c) 2002-2005 Stphane Gurin (zeitnot@gmail.com)
'
' This file is part of ZeitFrameCtl.
'    ZeitFrameCtl is free software; you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation; either version 2 of the License, or
'    (at your option) any later version.
'
'    ZeitFrameCtl is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with ZeitFrameCtl; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

' ZeitFrameCtl is container control (a frame) that enables the use of checkbox with the frame's caption.
' Ideally, the checkbox value determines if all the contained controls in the frame will be enabled or not (if they support that property).
' The ZeitFrameCtl can also act as a regular frame control.
' The ZeitFrameCtl can also have no caption via its CaptionControl property. This in effect remove the caption all together
' and properly sets the frame's top border as the Top values of the frame. The VB frame control does not allow for this and
' the programmer always have to calculate the Top propery of the frame minus the height of the caption's font.
' With the ZeitFrameCtl, when the programmer sets the CaptionControl property to zfNone, no caption is displayed and
' the frame's Top property becomes also the top of the frame.
' The ZeitFrameCtl also provide for a caption alignment property.
' All other properties from the standard VB frame control should be supported.

Public Enum zfCaptionControl
    zfNone = 0
    zfCheckbox = 1
    zfLabel = 2
End Enum

Public Enum zfCaptionAlign
    zfccLeft = 0
    zfccRight = 1
    zfccCenter = 2
End Enum

Public Enum zfBorderStyle
    zfbsNone = 0
    zfbsFixedSingle = 1
End Enum

Public Enum zfBackStyle
    Opaque = 1
    Transparent = 0
End Enum

'Default Property Values:
Const m_def_BorderStyle = zfbsFixedSingle
Const m_def_CaptionControl = zfCheckbox
Const m_def_CaptionAlign = zfccLeft
Const m_def_CaptionPad = 8          '8 pixels left or right for the caption. Act as a margin.
'Const m_def_CaptionControl = 1
'Property Variables:
Dim m_BorderStyle As zfBorderStyle
Dim m_CaptionControl As zfCaptionControl
Dim m_CaptionAlign As zfCaptionAlign
'Dim m_CaptionControl As zfCaptionControl
Dim m_BorderOffset As Integer
'Event Declarations:
Event OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,OLEDragDrop
Attribute OLEDragDrop.VB_Description = "Occurs when data is dropped onto the control via an OLE drag/drop operation, and OLEDropMode is set to manual."
Event Click() 'MappingInfo=UserControl,UserControl,-1,Click
Event DblClick() 'MappingInfo=UserControl,UserControl,-1,DblClick
Event KeyDown(KeyCode As Integer, Shift As Integer) 'MappingInfo=UserControl,UserControl,-1,KeyDown
Event KeyPress(KeyAscii As Integer) 'MappingInfo=UserControl,UserControl,-1,KeyPress
Event KeyUp(KeyCode As Integer, Shift As Integer) 'MappingInfo=UserControl,UserControl,-1,KeyUp
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseDown
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseMove
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseUp
Attribute MouseUp.VB_UserMemId = -607
'
Private Sub lblzFrame_Click()

    If m_CaptionControl = zfCheckbox Then
        If ZeitFrameCtl.Value = 1 Then
            ZeitFrameCtl.Value = 0
        Else
            ZeitFrameCtl.Value = 1
        End If
        Call ZeitFrameCtl_Click
    End If
End Sub

Private Sub UserControl_AmbientChanged(PropertyName As String)
    Debug.Print "UserControl_AmbientChanged PropertyName =" & PropertyName
    Select Case PropertyName
'''    Case "Font"
'''        Set UserControl.Font = Ambient.Font
    Case "BackColor"
        UserControl.BackColor = Ambient.BackColor
    Case "ForeColor"
        UserControl.ForeColor = Ambient.ForeColor
            
    End Select
'     Call UserControl_Paint
    
End Sub


Private Sub RedrawAll()
Dim sngTemp As Single, ctlRec As RECT
Dim lngCheckwidth As Long
Dim strCaption As String
    
    Set lblzFrame.Font = UserControl.Font       'makes the font persistent between creation and run-time.
               
    Select Case m_CaptionControl
    Case zfNone
        ZeitFrameCtl.Visible = False
        lblzFrame.Visible = False
        m_BorderOffset = 0
        lngCheckwidth = 0
    Case zfLabel
        ZeitFrameCtl.Visible = False
        'TODO: make it invisible if caption is empty.
        lblzFrame.Visible = True
        lblzFrame.Top = ZeitFrameCtl.Top
        m_BorderOffset = 8
        lngCheckwidth = 0
    Case zfCheckbox
        ZeitFrameCtl.Visible = True     'show checkbox
        lblzFrame.Visible = True        'show label
        lblzFrame.Top = ZeitFrameCtl.Top
        m_BorderOffset = 8
        lngCheckwidth = 18
    Case Else
    
    End Select
''    ctlRec.Top = UserControl.Top + m_BorderOffset
''    ctlRec.Left = UserControl.Left '+ m_BorderOffset
    ctlRec.Top = m_BorderOffset
    ctlRec.Left = 0
    ctlRec.Bottom = CLng(UserControl.Height / Screen.TwipsPerPixelY)
    ctlRec.Right = CLng(UserControl.Width / Screen.TwipsPerPixelX)
'    lblDebug.Caption = "ctlRec.Bottom = " & ctlRec.Bottom & " ctlRec.Right = " & ctlRec.Right
    UserControl.Cls
    'api drawing:
    If m_BorderStyle = zfbsFixedSingle Then     'if user wants visible 3d edges
        DrawEdgeCtl UserControl.hdc, ctlRec
    End If
    
    'align check and label:
    'TODO: adjust when caption is empty string.
    Select Case m_CaptionAlign
    Case zfccLeft
        'Debug.Print "  <zfccLeft ...lblzFrame.Left = " & lblzFrame.Left;
        lblzFrame.Left = m_def_CaptionPad + lngCheckwidth
        ZeitFrameCtl.Left = m_def_CaptionPad
        ZeitFrameCtl.Alignment = 0
        'Debug.Print "  ...lblzFrame.Left = " & lblzFrame.Left;
        'Debug.Print "  ...zfccLeft>";
    Case zfccRight
        'Debug.Print "  <zfccRight ...lblzFrame.Left = " & lblzFrame.Left;
        lblzFrame.Left = UserControl.ScaleWidth - m_def_CaptionPad - lngCheckwidth - lblzFrame.Width
        ZeitFrameCtl.Left = UserControl.ScaleWidth - lngCheckwidth - m_def_CaptionPad
        ZeitFrameCtl.Alignment = 1
        'Debug.Print "  ...lblzFrame.Left = " & lblzFrame.Left;
        'Debug.Print "  ...zfccRight>";
    Case zfccCenter
        'Debug.Print "  <zfccCenter ...lblzFrame.Left = " & lblzFrame.Left & "  UserControl.ScaleWidth=" & UserControl.ScaleWidth;
        'Debug.Print "  lblzFrame.Width=" & lblzFrame.Width;
        lblzFrame.Left = CLng((UserControl.ScaleWidth - lblzFrame.Width) / 2)
        ZeitFrameCtl.Left = lblzFrame.Left - lngCheckwidth ''- m_def_CaptionPad
        ZeitFrameCtl.Alignment = 0
        'Debug.Print "  ...lblzFrame.Left = " & lblzFrame.Left;
        'Debug.Print "  ...zfccCenter>";
    End Select
     'Debug.Print " ... RedrawAll>"
End Sub

Private Sub UserControl_Paint()
    Call RedrawAll
End Sub

Private Sub UserControl_Resize()
    Call UserControl_Paint
End Sub

Private Sub FlipEnable(ByVal intNewState As Integer)
Dim oneControl As Control
On Error Resume Next

    If intNewState = 1 Then
        If ZeitFrameCtl.Value = 1 Then
            For Each oneControl In UserControl.ContainedControls
                oneControl.Enabled = True
                oneControl.ForeColor = vbButtonText
            Next
        End If
'        Debug.Print "FlipEnable true?" & intNewState
    Else
        For Each oneControl In UserControl.ContainedControls
            oneControl.Enabled = False
            oneControl.ForeColor = vbGrayText
        Next
'        Debug.Print "FlipEnable false?" & intNewState
    End If
End Sub


Private Sub ZeitFrameCtl_Click()
'    Debug.Print "check value=" & ZeitFrameCtl.Value
    FlipEnable ZeitFrameCtl.Value
End Sub

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_BorderOffset = 6
'    Debug.Print "<UserControl_InitProperties ... ";
'    Debug.Print "UserControl.Font=" & UserControl.Font;
'    Set Font = UserControl.Ambient.Font
    Set Font = Extender.Parent.Font
    PropertyChanged "Font"
'    Debug.Print " ... UserControl.Font=" & UserControl.Font;
'    Debug.Print " ... UserControl_InitProperties>"
    UserControl.BackColor = Extender.Parent.BackColor
    PropertyChanged "BackColor"
    UserControl.ForeColor = Extender.Parent.ForeColor
    PropertyChanged "ForeColor"
    
    Caption = Extender.Name
    PropertyChanged "Caption"
    ZeitFrameCtl.Caption = ""
    m_CaptionControl = m_def_CaptionControl
    m_BorderStyle = m_def_BorderStyle
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    UserControl.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
    UserControl.ForeColor = PropBag.ReadProperty("ForeColor", &H8000000F)
    UserControl.Enabled = PropBag.ReadProperty("Enabled", True)
    Set UserControl.Font = PropBag.ReadProperty("Font", Ambient.Font)
    lblzFrame.Caption = PropBag.ReadProperty("Caption", "Caption")
    ZeitFrameCtl.Value = PropBag.ReadProperty("Value", vbChecked)
    m_CaptionControl = PropBag.ReadProperty("CaptionControl", m_def_CaptionControl)
    m_CaptionAlign = PropBag.ReadProperty("CaptionAlign", m_def_CaptionAlign)
    Set MouseIcon = PropBag.ReadProperty("MouseIcon", Nothing)
    UserControl.MousePointer = PropBag.ReadProperty("MousePointer", vbDefault)
'    UserControl.OLEDropMode = PropBag.ReadProperty("OLEDropMode", 1)
    
    m_BorderStyle = PropBag.ReadProperty("BorderStyle", m_def_BorderStyle)
    UserControl.BackStyle = PropBag.ReadProperty("BackStyle", 1)
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    
    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H8000000F)
    Call PropBag.WriteProperty("ForeColor", UserControl.ForeColor, &H8000000F)
    Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
    Call PropBag.WriteProperty("Font", UserControl.Font, Ambient.Font)
        
    Call PropBag.WriteProperty("Caption", lblzFrame.Caption, "Caption")
    Call PropBag.WriteProperty("Value", ZeitFrameCtl.Value, vbChecked)
    Call PropBag.WriteProperty("CaptionControl", m_CaptionControl, m_def_CaptionControl)
    Call PropBag.WriteProperty("MouseIcon", MouseIcon, Nothing)
    Call PropBag.WriteProperty("MousePointer", UserControl.MousePointer, vbDefault)
    
    Call PropBag.WriteProperty("CaptionAlign", m_CaptionAlign, m_def_CaptionAlign)
'    Call PropBag.WriteProperty("OLEDropMode", UserControl.OLEDropMode, 1)
    
    Call PropBag.WriteProperty("BorderStyle", m_BorderStyle, m_def_BorderStyle)
    Call PropBag.WriteProperty("BackStyle", UserControl.BackStyle, 1)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
    BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    UserControl.BackColor() = New_BackColor
    PropertyChanged "BackColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,ForeColor
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
    ForeColor = UserControl.ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    UserControl.ForeColor() = New_ForeColor
    PropertyChanged "ForeColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Enabled
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    UserControl.Enabled() = New_Enabled
    PropertyChanged "Enabled"
    
    FlipEnable Abs(Int(New_Enabled))
    ZeitFrameCtl.Enabled = New_Enabled
    lblzFrame.Enabled = New_Enabled
    
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Font
Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_UserMemId = -512
    Set Font = UserControl.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    
    Set UserControl.Font = New_Font
    
    PropertyChanged "Font"
    lblzFrame.AutoSize = True
    Set lblzFrame.Font = New_Font
    lblzFrame.AutoSize = False
    lblzFrame.Width = lblzFrame.Width + 8   'add space for label to breath
    
'    Debug.Print "=Set Font New_Font=" & New_Font
    ''''Set Extender.Font = New_Font    'bad bad bad call -> infinite loop
'    Call UserControl_Paint
    Call RedrawAll
    
End Property

Private Sub DebugAmbient()
'    Debug.Print "DebugAmbient starts"
'    Debug.Print "BackColor" & UserControl.Ambient.BackColor
'    Debug.Print "Font" & UserControl.Ambient.Font
'    Debug.Print "UserMode" & UserControl.Ambient.UserMode
'    Debug.Print "MessageReflect" & UserControl.Ambient.MessageReflect
'    Debug.Print "DebugAmbient ends"
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Refresh
Public Sub Refresh()
Attribute Refresh.VB_Description = "Forces a complete repaint of a object."
Attribute Refresh.VB_UserMemId = -550
    UserControl.Refresh
End Sub

Private Sub UserControl_Click()
    RaiseEvent Click
End Sub

Private Sub UserControl_DblClick()
    RaiseEvent DblClick
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
    RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub UserControl_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUp(KeyCode, Shift)
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub
'
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=lblzFrame,lblzFrame,-1,Caption
Public Property Get Caption() As String
Attribute Caption.VB_Description = "Returns/sets the text displayed in an object's title bar or below an object's icon."
Attribute Caption.VB_ProcData.VB_Invoke_Property = ";Text"
Attribute Caption.VB_UserMemId = -518
    Caption = lblzFrame.Caption
End Property

Public Property Let Caption(ByVal New_Caption As String)
'    Debug.Print "Let Caption... " & New_Caption
    lblzFrame.AutoSize = True
    lblzFrame.Caption() = New_Caption
    lblzFrame.AutoSize = False
    lblzFrame.Width = lblzFrame.Width + 8
    If Len(New_Caption) > 0 Then
        lblzFrame.Visible = True
        ZeitFrameCtl.Width = 18
    Else
        lblzFrame.Visible = False
        ZeitFrameCtl.Width = 12
    End If
    'TODO: label can be right or left of the checkbox
    lblzFrame.Left = ZeitFrameCtl.Left + 14
    PropertyChanged "Caption"
End Property
'
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=ZeitFrameCtl,ZeitFrameCtl,-1,Value
Public Property Get Value() As CheckBoxConstants
Attribute Value.VB_Description = "Returns/sets the value of an object."
    Value = ZeitFrameCtl.Value
End Property

Public Property Let Value(ByVal New_Value As CheckBoxConstants)
    ZeitFrameCtl.Value() = New_Value
    PropertyChanged "Value"
    
    ZeitFrameCtl.Value = New_Value
    If New_Value = vbGrayed Then
        lblzFrame.Enabled = False
    Else
        lblzFrame.Enabled = True
    End If
        
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=23,0,0,1
Public Property Get CaptionControl() As zfCaptionControl
Attribute CaptionControl.VB_Description = "Determine if a checkbox will enable/disable the ZeitFrameCtl"
    CaptionControl = m_CaptionControl
End Property

Public Property Let CaptionControl(ByVal New_CaptionControl As zfCaptionControl)
    m_CaptionControl = New_CaptionControl
    PropertyChanged "CaptionControl"
    Call RedrawAll
End Property

Public Property Get CaptionAlign() As zfCaptionAlign
    CaptionAlign = m_CaptionAlign
End Property

Public Property Let CaptionAlign(ByVal New_CaptionAlign As zfCaptionAlign)
Dim old As zfCaptionAlign
    old = m_CaptionAlign
    m_CaptionAlign = New_CaptionAlign
    PropertyChanged "CaptionAlign"
    If old <> New_CaptionAlign Then
        Call RedrawAll
    End If
End Property
'
'
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,MouseIcon
Public Property Get MouseIcon() As Picture
Attribute MouseIcon.VB_Description = "Sets a custom mouse icon."
    Set MouseIcon = UserControl.MouseIcon
End Property

Public Property Set MouseIcon(ByVal New_MouseIcon As Picture)
    Set UserControl.MouseIcon = New_MouseIcon
    PropertyChanged "MouseIcon"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,MousePointer
Public Property Get MousePointer() As MousePointerConstants
Attribute MousePointer.VB_Description = "Returns/sets the type of mouse pointer displayed when over part of an object."
    MousePointer = UserControl.MousePointer
End Property

Public Property Let MousePointer(ByVal New_MousePointer As MousePointerConstants)
    UserControl.MousePointer() = New_MousePointer
    PropertyChanged "MousePointer"
End Property

Private Sub UserControl_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent OLEDragDrop(Data, Effect, Button, Shift, X, Y)
End Sub
''
'''WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'''MappingInfo=UserControl,UserControl,-1,OLEDropMode
''Public Property Get OLEDropMode() As Integer
''    OLEDropMode = UserControl.OLEDropMode
''End Property
''
''Public Property Let OLEDropMode(ByVal New_OLEDropMode As Integer)
''    UserControl.OLEDropMode() = New_OLEDropMode
''    PropertyChanged "OLEDropMode"
''End Property
''
'
'
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=27,0,0,1
Public Property Get BorderStyle() As zfBorderStyle
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
    BorderStyle = m_BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As zfBorderStyle)
    m_BorderStyle = New_BorderStyle
    PropertyChanged "BorderStyle"
    Call RedrawAll
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BackStyle
Public Property Get BackStyle() As zfBackStyle
Attribute BackStyle.VB_Description = "Indicates whether a Label or the background of a Shape is transparent or opaque."
    BackStyle = UserControl.BackStyle
End Property

Public Property Let BackStyle(ByVal New_BackStyle As zfBackStyle)
    UserControl.BackStyle() = New_BackStyle
    PropertyChanged "BackStyle"
    lblzFrame.BackStyle = New_BackStyle
    Call RedrawAll
End Property

