Attribute VB_Name = "modLine"
Option Explicit
' Copyright (c) 2002-2005 Stphane Gurin (zeitnot@gmail.com)
'
' This file is part of ZeitFrameCtl.
'    ZeitFrameCtl is free software; you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation; either version 2 of the License, or
'    (at your option) any later version.
'
'    ZeitFrameCtl is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with ZeitFrameCtl; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

' modLine.bas: API functions for the ZeitFrameCtl.
' This library only uses four API calls, 2 from gdi32.dll and the 2 others from user32.dll
'Three functions are defined:
' DrawEdgeCtl for the style of the frame's border.
' DrawLines for the basic redraw of the frame's border.
' RedrawCtl to redraw the entire frame.

Private Type POINTAPI
    X As Long
    Y As Long
End Type

Public Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Const RDW_INVALIDATE = &H1

Public Const BDR_INNER = &HC
Public Const BDR_OUTER = &H3
Public Const BDR_RAISED = &H5
Public Const BDR_RAISEDINNER = &H4
Public Const BDR_RAISEDOUTER = &H1
Public Const BDR_SUNKEN = &HA
Public Const BDR_SUNKENINNER = &H8
Public Const BDR_SUNKENOUTER = &H2

Public Const EDGE_BUMP = (BDR_RAISEDOUTER Or BDR_SUNKENINNER)
Public Const EDGE_ETCHED = (BDR_SUNKENOUTER Or BDR_RAISEDINNER)
Public Const EDGE_RAISED = (BDR_RAISEDOUTER Or BDR_RAISEDINNER)
Public Const EDGE_SUNKEN = (BDR_SUNKENOUTER Or BDR_SUNKENINNER)

Public Const BF_ADJUST = &H2000  ' Calculate the space left over.
Public Const BF_BOTTOM = &H8

Public Const BF_FLAT = &H4000   ' For flat rather than 3-D borders.
Public Const BF_LEFT = &H1
Public Const BF_MIDDLE = &H800  ' Fill the middle.
Public Const BF_MONO = &H8000   ' For monochrome borders.
Public Const BF_RIGHT = &H4
Public Const BF_SOFT = &H1000   ' Use for softer buttons.
Public Const BF_TOP = &H2
Public Const BF_RECT = (BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM)
Public Const BF_TOPLEFT = (BF_TOP Or BF_LEFT)
Public Const BF_TOPRIGHT = (BF_TOP Or BF_RIGHT)
Public Const BF_BOTTOMLEFT = (BF_BOTTOM Or BF_LEFT)
Public Const BF_BOTTOMRIGHT = (BF_BOTTOM Or BF_RIGHT)
Public Const BF_DIAGONAL = &H10
Public Const BF_DIAGONAL_ENDBOTTOMLEFT = (BF_DIAGONAL Or BF_BOTTOM Or BF_LEFT)
Public Const BF_DIAGONAL_ENDBOTTOMRIGHT = (BF_DIAGONAL Or BF_BOTTOM Or BF_RIGHT)
Public Const BF_DIAGONAL_ENDTOPLEFT = (BF_DIAGONAL Or BF_TOP Or BF_LEFT)
Public Const BF_DIAGONAL_ENDTOPRIGHT = (BF_DIAGONAL Or BF_TOP Or BF_RIGHT)

Private Declare Function LineTo Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, lpPoint As POINTAPI) As Long
Private Declare Function RedrawWindow Lib "user32" (ByVal hwnd As Long, lprcUpdate As Any, ByVal hrgnUpdate As Long, ByVal fuRedraw As Long) As Long
Private Declare Function DrawEdge Lib "user32" (ByVal hdc As Long, qrc As RECT, ByVal edge As Long, ByVal grfFlags As Long) As Long

Public Function DrawEdgeCtl(ByVal OneHdc As Long, ByRef ctlRec As RECT) As Boolean
Dim ret As Boolean
    DrawEdge OneHdc, ctlRec, EDGE_ETCHED, BF_RECT
End Function


Public Function DrawLines(ByVal OneHdc As Long, ByVal lngHeight As Long, ByVal lngWidth As Long) As Boolean

    Dim myPoint As POINTAPI
    MoveToEx OneHdc, 0, 0, myPoint
    LineTo OneHdc, lngWidth, lngHeight
End Function

Public Function RedrawCtl(ByVal OneHwnd As Long) As Boolean

    RedrawWindow OneHwnd, ByVal 0&, ByVal 0&, RDW_INVALIDATE

End Function
